Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs	(revision 15334)
@@ -1,67 +1,187 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Configuration {
   using System.Collections.Generic;
-  using Base.Erc;
-  using Common;
-  using Persistence.Default.CompositeSerializers.Storable;
+
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Data;
+  using HeuristicLab.Parameters;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc;
 
   [StorableClass]
   public class PushConfiguration : PushConfigurationBase, IReadOnlyPushConfiguration {
+    private const string INSTRUCTIONS_PARAMETER_NAME = "Instructions";
+    private const string INSTRUCTIONS_PARAMETER_DESCRIPTION = "Enables/Disables Instructions";
+    private const string EVAL_PUSH_LIMIT_PARAMETER_NAME = "EvalPushLimit";
+    private const string EVAL_PUSH_LIMIT_PARAMETER_DESCRIPTION = "This is the maximum allowed number of \"executions\" in a single top-level call to the interpreter. The execution of a single Push instruction counts as one execution, as does the processing of a single literal, as does the descent into one layer of parentheses (that is, the processing of the \"(\" counts as one execution).";
+    private const string MIN_PROGRAM_LENGTH = "MinProgramLength";
+    private const string MIN_PROGRAM_LENGTH_PARAMETER_DESCRIPTION = "This is the minium size of an item on the CODE/EXEC stack, expressed as a number of points. A point is an instruction, a literal, or a pair of parentheses.";
+    private const string MAX_PROGRAM_LENGTH = "MaxProgramLength";
+    private const string MAX_PROGRAM_LENGTH_PARAMETER_DESCRIPTION = "This is the maximum size of an item on the CODE/EXEC stack, expressed as a number of points. A point is an instruction, a literal, or a pair of parentheses.";
+    private const string TOP_LEVEL_PUSH_CODE_PARAMETER_NAME = "TopLevelPushCode";
+    private const string TOP_LEVEL_PUSH_CODE_PARAMETER_DESCRIPTION = "When TRUE (which is the default), code passed to the top level of the interpreter will be pushed onto the CODE stack prior to execution.";
+    private const string TOP_LEVEL_POP_CODE_PARAMETER_NAME = "TopLevelPopCode";
+    private const string TOP_LEVEL_POP_CODE_PARAMETER_DESCRIPTION = "When TRUE, the CODE stack will be popped at the end of top level calls to the interpreter. The default is FALSE.";
+    private const string MAX_POINTS_IN_RANDOM_INSTRUCTION_PARAMETER_NAME = "MaxPointsInRandomInstruction";
+    private const string MAX_POINTS_IN_RANDOM_INSTRUCTION_PARAMETER_DESCRIPTION = "MaxPointsInRandomInstruction";
+    private const string ERC_OPTIONS_PARAMETER_NAME = "ERC options";
+    private const string MAX_STRING_LENGTH_PARAMETER_NAME = "Max. string length of string literals";
+    private const string MAX_DEPTH_PARAMETER_NAME = "Max. depth of a Push program";
+    private const string MAX_CLOSE_PARAMETER_NAME = "Max. close";
+    private const string MAX_PARENTHESES_CLOSE_PARAMETER_DESCRIPTION = "Specifies how many sub programs are max. closed if open during the recursive translation of an individual to a push program. Value is exclusive.";
+    private const string CLOSE_BIAS_LEVEL_PARAMETER_NAME = "Close bias level";
+    private const string PARENTHESES_CLOSE_BIAS_LEVEL_PARAMETER_DESCRIPTION = "Specifies how strong a random value between 0 .. 'Max. parentheses close' is biased towards 0. In other words, this parameter controls the length of sub programs.";
+    private const string MAX_VECTOR_LENGTH_PARAMETER_NAME = "Max. vector length";
+    private const string TOP_LEVEL_PUSH_INPUT_ARGUMENTS = "TopLevelPushInputArguments";
+
     public PushConfiguration() {
-      Name = "Push Configuration";
-
-      ErcOptions = new ErcOptions();
-      EvalPushLimit = 1024;
-      MinPointsInProgram = 25;
-      MaxPointsInProgram = 200;
-      TopLevelPushCode = true;
-      TopLevelPopCode = false;
-      MaxPointsInRandomExpression = 64;
-      MaxStringLength = 1000;
-      MaxVectorLength = 500;
-      MaxDepth = 100;
+      Parameters = new ParameterCollection();
+      InitParameters();
+
       FloatStringFormat = "R";
-      MaxParenthesesClose = 4;
-      ParenthesesCloseBiasLevel = 1;
-    }
-
+    }
+
+    public PushConfiguration(PushConfiguration origin, Cloner cloner) : base(origin, cloner) {
+      Parameters = cloner.Clone(origin.Parameters);
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PushConfiguration(this, cloner);
+    }
 
     [StorableConstructor]
-    public PushConfiguration(bool deserializing)
-      : base(deserializing) {
-    }
-
-    public PushConfiguration(PushConfiguration origin, Cloner cloner) : base(origin, cloner) {
-
-      ErcOptions = cloner.Clone(origin.ErcOptions);
-      EvalPushLimit = origin.EvalPushLimit;
-      MinPointsInProgram = origin.MinPointsInProgram;
-      MaxPointsInProgram = origin.MaxPointsInProgram;
-      MaxPointsInRandomExpression = origin.MaxPointsInRandomExpression;
-      TopLevelPushCode = origin.TopLevelPushCode;
-      TopLevelPopCode = origin.TopLevelPopCode;
-      MaxStringLength = origin.MaxStringLength;
-      MaxVectorLength = origin.MaxVectorLength;
-      MaxDepth = origin.MaxDepth;
-      FloatStringFormat = origin.FloatStringFormat;
-      MaxParenthesesClose = origin.MaxParenthesesClose;
-      ParenthesesCloseBiasLevel = origin.ParenthesesCloseBiasLevel;
-    }
+    protected PushConfiguration(bool deserialize) { }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    // ReSharper disable once UnusedMember.Local
+    private void AfterDeserialization() {
+      InitParameters();
+    }
+
+    [Storable]
+    public ParameterCollection Parameters { get; private set; }
 
     [Storable]
     public string FloatStringFormat { get; set; }
 
-
-    IReadOnlyList<string> IReadOnlyExpressionsConfiguration.EnabledExpressions { get { return enabledExpressions; } }
-
-    [Storable]
-    public int MaxParenthesesClose { get; set; }
-    [Storable]
-    public double ParenthesesCloseBiasLevel { get; set; }
-
-
-    [Storable]
-    public ErcOptions ErcOptions { get; set; }
-
-    IReadOnlyErcOptions IReadOnlyPushConfiguration.ErcOptions { get { return ErcOptions; } }
+    private void InitParameters() {
+      if (!Parameters.ContainsKey(INSTRUCTIONS_PARAMETER_NAME))
+        Parameters.Add(new ValueParameter<IExpressionsConfiguration>(
+          INSTRUCTIONS_PARAMETER_NAME,
+          INSTRUCTIONS_PARAMETER_DESCRIPTION,
+          this));
+
+      if (!Parameters.ContainsKey(ERC_OPTIONS_PARAMETER_NAME))
+        Parameters.Add(new ValueParameter<ErcOptions>(ERC_OPTIONS_PARAMETER_NAME));
+
+      if (!Parameters.ContainsKey(MAX_VECTOR_LENGTH_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MAX_VECTOR_LENGTH_PARAMETER_NAME,
+          new IntValue(500)) { Hidden = true });
+
+      if (!Parameters.ContainsKey(EVAL_PUSH_LIMIT_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          EVAL_PUSH_LIMIT_PARAMETER_NAME,
+          EVAL_PUSH_LIMIT_PARAMETER_DESCRIPTION,
+          new IntValue(1000)));
+
+      if (!Parameters.ContainsKey(MAX_PROGRAM_LENGTH))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MAX_PROGRAM_LENGTH,
+          MAX_PROGRAM_LENGTH_PARAMETER_DESCRIPTION,
+          new IntValue(200)));
+
+      if (!Parameters.ContainsKey(MIN_PROGRAM_LENGTH))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MIN_PROGRAM_LENGTH,
+          MIN_PROGRAM_LENGTH_PARAMETER_DESCRIPTION,
+          new IntValue(0)) { Hidden = true });
+
+      if (!Parameters.ContainsKey(MAX_CLOSE_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MAX_CLOSE_PARAMETER_NAME,
+          MAX_PARENTHESES_CLOSE_PARAMETER_DESCRIPTION,
+          new IntValue(4)) { Hidden = false });
+
+      if (!Parameters.ContainsKey(CLOSE_BIAS_LEVEL_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<DoubleValue>(
+          CLOSE_BIAS_LEVEL_PARAMETER_NAME,
+          PARENTHESES_CLOSE_BIAS_LEVEL_PARAMETER_DESCRIPTION,
+          new DoubleValue(3)) { Hidden = false });
+
+      if (!Parameters.ContainsKey(TOP_LEVEL_PUSH_CODE_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<BoolValue>(
+          TOP_LEVEL_PUSH_CODE_PARAMETER_NAME,
+          TOP_LEVEL_PUSH_CODE_PARAMETER_DESCRIPTION,
+          new BoolValue(true)) { Hidden = true });
+
+      if (!Parameters.ContainsKey(TOP_LEVEL_POP_CODE_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<BoolValue>(
+          TOP_LEVEL_POP_CODE_PARAMETER_NAME,
+          TOP_LEVEL_POP_CODE_PARAMETER_DESCRIPTION,
+          new BoolValue(false)) { Hidden = true });
+
+      if (!Parameters.ContainsKey(MAX_POINTS_IN_RANDOM_INSTRUCTION_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MAX_POINTS_IN_RANDOM_INSTRUCTION_PARAMETER_NAME,
+          MAX_POINTS_IN_RANDOM_INSTRUCTION_PARAMETER_DESCRIPTION,
+          new IntValue(50)) { Hidden = true });
+
+      if (!Parameters.ContainsKey(MAX_STRING_LENGTH_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MAX_STRING_LENGTH_PARAMETER_NAME,
+          new IntValue(1000)) { Hidden = true });
+
+      if (!Parameters.ContainsKey(MAX_DEPTH_PARAMETER_NAME))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MAX_DEPTH_PARAMETER_NAME,
+          new IntValue(1000)) { Hidden = true });
+
+      if (!Parameters.ContainsKey(TOP_LEVEL_PUSH_INPUT_ARGUMENTS))
+        Parameters.Add(new FixedValueParameter<BoolValue>(
+          TOP_LEVEL_PUSH_INPUT_ARGUMENTS,
+          new BoolValue(true)) { Hidden = false });
+    }
+
+    public IValueParameter<IExpressionsConfiguration> InstructionsParameter
+    {
+      get { return (IValueParameter<IExpressionsConfiguration>)Parameters[INSTRUCTIONS_PARAMETER_NAME]; }
+    }
+
+    public IExpressionsConfiguration Instructions
+    {
+      get { return InstructionsParameter.Value; }
+      set { InstructionsParameter.Value = value; }
+    }
+
+    public IValueParameter<ErcOptions> ErcOptionsParameter
+    {
+      get { return (IValueParameter<ErcOptions>)Parameters[ERC_OPTIONS_PARAMETER_NAME]; }
+    }
+
+    public ErcOptions ErcOptions
+    {
+      get { return ErcOptionsParameter.Value; }
+      set
+      {
+        ErcOptionsParameter.Value = value;
+      }
+    }
+
+    IReadOnlyList<string> IReadOnlyExpressionsConfiguration.EnabledExpressions
+    {
+      get
+      {
+        return enabledExpressions;
+      }
+    }
+
+    IReadOnlyErcOptions IReadOnlyPushConfiguration.ErcOptions
+    {
+      get
+      {
+        return ErcOptions;
+      }
+    }
 
     /// <summary>
@@ -74,21 +194,79 @@
     ///     is up to the calling program.
     /// </summary>
-    [Storable]
-    public int EvalPushLimit { get; set; }
+    public IValueParameter<IntValue> EvalPushLimitParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[EVAL_PUSH_LIMIT_PARAMETER_NAME]; }
+    }
+
+    public int EvalPushLimit
+    {
+      get { return EvalPushLimitParameter.Value.Value; }
+      set { EvalPushLimitParameter.Value.Value = value; }
+    }
+
+
+    /// <summary>
+    /// Determines the likelihood of smaller or bigger values.
+    /// x greater than 1 means that result is biased towards min.
+    /// x smaller than 1 means that result is biased towards max.
+    /// </summary>
+    public IValueParameter<DoubleValue> CloseBiasLevelParameter
+    {
+      get { return (IValueParameter<DoubleValue>)Parameters[CLOSE_BIAS_LEVEL_PARAMETER_NAME]; }
+    }
+
+    public double CloseBiasLevel
+    {
+      get { return CloseBiasLevelParameter.Value.Value; }
+      set { CloseBiasLevelParameter.Value.Value = value; }
+    }
+
+    /// <summary>
+    /// Determines the maximum of blocks which will be closed.
+    /// </summary>
+    public IValueParameter<IntValue> MaxCloseParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[MAX_CLOSE_PARAMETER_NAME]; }
+    }
+
+    public int MaxClose
+    {
+      get { return MaxCloseParameter.Value.Value; }
+      set
+      {
+        MaxCloseParameter.Value.Value = value;
+      }
+    }
 
     /// <summary>
     /// This is the maximum of depth a push program can have. Expressions, which lead to exceed this limit are interpreted as NOOP.
     /// </summary>
-    [Storable]
-    public int MaxDepth { get; set; }
-
-    /// <summary>
-    ///     This is the minimum size of an item on the CODE stack, expressed as a number of points.
-    ///     A point is an instruction, a literal, or a pair of parentheses. Any instruction that would cause this limit to be
-    ///     exceeded should instead act as a NOOP, leaving all stacks in the states that they were in before the execution of the
-    ///     instruction.
-    /// </summary>
-    [Storable]
-    public int MinPointsInProgram { get; set; }
+    public IValueParameter<IntValue> MaxDepthParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[MAX_DEPTH_PARAMETER_NAME]; }
+    }
+
+    public int MaxDepth
+    {
+      get { return MaxDepthParameter.Value.Value; }
+      set
+      {
+        MaxDepthParameter.Value.Value = value;
+      }
+    }
+
+    public IValueParameter<IntValue> MinProgramLengthParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[MIN_PROGRAM_LENGTH]; }
+    }
+
+    public int MinProgramLength
+    {
+      get { return MinProgramLengthParameter.Value.Value; }
+      set
+      {
+        MinProgramLengthParameter.Value.Value = value;
+      }
+    }
 
     /// <summary>
@@ -98,12 +276,45 @@
     ///     instruction.
     /// </summary>
-    [Storable]
-    public int MaxPointsInProgram { get; set; }
+    public IValueParameter<IntValue> MaxProgramLengthParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[MAX_PROGRAM_LENGTH]; }
+    }
+
+    public int MaxProgramLength
+    {
+      get { return MaxProgramLengthParameter.Value.Value; }
+      set
+      {
+        MaxProgramLengthParameter.Value.Value = value;
+      }
+    }
+
+    public IValueParameter<IntValue> MaxVectorLengthParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[MAX_VECTOR_LENGTH_PARAMETER_NAME]; }
+    }
+
+    public int MaxVectorLength
+    {
+      get { return MaxVectorLengthParameter.Value.Value; }
+      set { MaxVectorLengthParameter.Value.Value = value; }
+    }
 
     /// <summary>
     ///     The maximum number of points in an expression produced by the CODE.RAND instruction.
     /// </summary>
-    [Storable]
-    public int MaxPointsInRandomExpression { get; set; }
+    public IValueParameter<IntValue> MaxPointsInRandomExpressionParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[MAX_POINTS_IN_RANDOM_INSTRUCTION_PARAMETER_NAME]; }
+    }
+
+    public int MaxPointsInRandomExpression
+    {
+      get { return MaxPointsInRandomExpressionParameter.Value.Value; }
+      set
+      {
+        MaxPointsInRandomExpressionParameter.Value.Value = value;
+      }
+    }
 
     /// <summary>
@@ -111,21 +322,55 @@
     ///     will be pushed onto the CODE stack prior to execution.
     /// </summary>
-    [Storable]
-    public bool TopLevelPushCode { get; set; }
+    public IValueParameter<BoolValue> TopLevelPushCodeParameter
+    {
+      get { return (IValueParameter<BoolValue>)Parameters[TOP_LEVEL_PUSH_CODE_PARAMETER_NAME]; }
+    }
+
+    public bool TopLevelPushCode
+    {
+      get { return TopLevelPushCodeParameter.Value.Value; }
+      set
+      {
+        TopLevelPushCodeParameter.Value.Value = value;
+      }
+    }
 
     /// <summary>
     ///     When TRUE, the CODE stack will be popped at the end of top level calls to the interpreter. The default is FALSE.
     /// </summary>
-    [Storable]
-    public bool TopLevelPopCode { get; set; }
-
-    [Storable]
-    public int MaxStringLength { get; set; }
-
-    [Storable]
-    public int MaxVectorLength { get; set; }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new PushConfiguration(this, cloner);
+    public IValueParameter<BoolValue> TopLevelPopCodeParameter
+    {
+      get { return (IValueParameter<BoolValue>)Parameters[TOP_LEVEL_POP_CODE_PARAMETER_NAME]; }
+    }
+
+    public bool TopLevelPopCode
+    {
+      get { return TopLevelPopCodeParameter.Value.Value; }
+      set
+      {
+        TopLevelPopCodeParameter.Value.Value = value;
+      }
+    }
+
+    public IValueParameter<IntValue> MaxStringLengthParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[MAX_STRING_LENGTH_PARAMETER_NAME]; }
+    }
+
+    public int MaxStringLength
+    {
+      get { return MaxStringLengthParameter.Value.Value; }
+      set { MaxStringLengthParameter.Value.Value = value; }
+    }
+
+    public IValueParameter<BoolValue> TopLevelPushInputArgumentsParameter
+    {
+      get { return (IValueParameter<BoolValue>)Parameters[TOP_LEVEL_PUSH_INPUT_ARGUMENTS]; }
+    }
+
+    public bool TopLevelPushInputArguments
+    {
+      get { return TopLevelPushInputArgumentsParameter.Value.Value; }
+      set { TopLevelPushInputArgumentsParameter.Value.Value = value; }
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Crossover/AlternationCrossover.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Crossover/AlternationCrossover.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Crossover/AlternationCrossover.cs	(revision 15334)
@@ -31,7 +31,9 @@
       ChildParameter.ActualName = "PlushVector";
 
+      Parameters.Add(new LookupParameter<IntValue>("MaxProgramLength", "The max length of children"));
+
       Parameters.Add(new FixedValueParameter<PercentValue>("AlternationRate", "Specifies the probability of switching to another parent.", new PercentValue(0.5)));
       Parameters.Add(new FixedValueParameter<DoubleValue>("AlignmentDeviation", "When alternating between parents, the index at which to continue copying may be offset backward or forward some amount based on a random sample from a normal distribution with mean 0 and standard deviation set by the alignment deviation parameter", new DoubleValue(1.0)));
-      Parameters.Add(new FixedValueParameter<IntValue>("MaxLength", "The max length of a children", new IntValue(100)));
+
     }
 
@@ -47,13 +49,13 @@
     }
 
-    public IValueParameter<IntValue> MaxLengthParameter
+    public ILookupParameter<IntValue> MaxProgramLengthParameter
     {
-      get { return (IValueParameter<IntValue>)Parameters["MaxLength"]; }
+      get { return (ILookupParameter<IntValue>)Parameters["MaxProgramLength"]; }
     }
 
-    public int MaxLength
+    public int MaxProgramLength
     {
-      get { return MaxLengthParameter.Value.Value; }
-      set { MaxLengthParameter.Value.Value = value; }
+      get { return MaxProgramLengthParameter.ActualValue.Value; }
+      set { MaxProgramLengthParameter.ActualValue.Value = value; }
     }
 
@@ -98,5 +100,5 @@
         ParentsParameter.ActualValue,
         AlternationRate,
-        MaxLength,
+        MaxProgramLength,
         AlignmentDeviation);
       return base.InstrumentedApply();
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/IPooledObject.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/IPooledObject.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/IPooledObject.cs	(revision 15334)
@@ -1,5 +1,4 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool {
   public interface IPooledObject {
-    void Init();
     void Reset();
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ManagedPoolProvider.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ManagedPoolProvider.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ManagedPoolProvider.cs	(revision 15334)
@@ -7,4 +7,6 @@
   using System.Reflection;
   using System.Runtime.Serialization.Formatters.Binary;
+
+  using Microsoft.IO;
 
   public interface IManagedPool<T> : IDisposable where T : class, IPooledObject {
@@ -17,6 +19,7 @@
     private readonly ObjectPool<IManagedPool<T>> managedPools;
     private readonly BinaryFormatter binaryFormatter = new BinaryFormatter();
+    private readonly RecyclableMemoryStreamManager recyclableMemoryStreamManager = new RecyclableMemoryStreamManager();
     private byte[] dummyPartition;
-    private static volatile object dummyCreationLockObject = new object();
+    private volatile object dummyCreationLockObject = new object();
 
     private static readonly FieldInfo InternalListArrayProperty = typeof(List<T[]>).GetField(
@@ -56,4 +59,5 @@
 
     private T[] CloneDummyPartition() {
+      // init dummy partition
       if (dummyPartition == null) {
         lock (dummyCreationLockObject) {
@@ -65,7 +69,7 @@
             }
 
-            using (var memoryStream = new MemoryStream()) {
-              binaryFormatter.Serialize(memoryStream, temp);
-              dummyPartition = memoryStream.ToArray();
+            using (var ms = recyclableMemoryStreamManager.GetStream("dummyPartition")) {
+              binaryFormatter.Serialize(ms, temp);
+              dummyPartition = ms.ToArray();
             }
           }
@@ -73,12 +77,7 @@
       }
 
-      using (var memoryStream = new MemoryStream(dummyPartition)) {
-        memoryStream.Seek(0, SeekOrigin.Begin);
-
-        var result = (T[])binaryFormatter.Deserialize(memoryStream);
-
-        for (var i = 0; i < result.Length; i++)
-          result[i].Init();
-
+      using (var ms = recyclableMemoryStreamManager.GetStream("dummyPartition", dummyPartition, 0, dummyPartition.Length)) {
+        ms.Seek(0, SeekOrigin.Begin);
+        var result = (T[])binaryFormatter.Deserialize(ms);
         return result;
       }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/PooledList.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/PooledList.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/PooledList.cs	(revision 15334)
@@ -6,9 +6,4 @@
   [Serializable]
   public class PooledList<T> : List<T>, IPooledObject {
-    public Guid Id { get; private set; }
-
-    void IPooledObject.Init() {
-      Id = Guid.NewGuid();
-    }
 
     void IPooledObject.Reset() {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/PooledObject.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/PooledObject.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/PooledObject.cs	(revision 15334)
@@ -20,6 +20,4 @@
     }
 
-    void IPooledObject.Init() { }
-
     public void Reset() {
       resetor(item);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushEncoding.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushEncoding.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Encoding/PlushEncoding.cs	(revision 15334)
@@ -27,14 +27,12 @@
       minLengthParameter = new FixedValueParameter<IntValue>(Name + ".MinLength", new IntValue(25));
       maxLengthParameter = new FixedValueParameter<IntValue>(Name + ".MaxLength", new IntValue(100));
-      minCloseParameter = new FixedValueParameter<IntValue>(Name + ".MinClose", new IntValue(0));
       maxCloseParameter = new FixedValueParameter<IntValue>(Name + ".MaxClose", new IntValue(3));
       closeBiasLevelParameter = new FixedValueParameter<DoubleValue>(Name + ".CloseBiasLevel", new DoubleValue(3d));
       instructionsParameter = new ValueParameter<IExpressionsConfiguration>(Name + ".Instructions");
       ercOptionsParameter = new ValueParameter<ErcOptions>(Name + ".ErcOptions");
-      inInstructionProbabilityParameter = new FixedValueParameter<PercentValue>(Name + ".InInstructionProbability");
+      inInstructionProbabilityParameter = new FixedValueParameter<PercentValue>(Name + ".InInstructionProbability", new PercentValue(0.1));
 
       Parameters.Add(minLengthParameter);
       Parameters.Add(maxLengthParameter);
-      Parameters.Add(minCloseParameter);
       Parameters.Add(maxCloseParameter);
       Parameters.Add(closeBiasLevelParameter);
@@ -78,8 +76,4 @@
       ConfigureOperators(Operators);
     }
-    private void OnMinCloseParameterChanged() {
-      RegisterMinCloseParameterEvents();
-      ConfigureOperators(Operators);
-    }
     private void OnMaxCloseParameterChanged() {
       RegisterMaxCloseParameterEvents();
@@ -106,5 +100,4 @@
       RegisterMinLengthParameterEvents();
       RegisterMaxLengthParameterEvents();
-      RegisterMinCloseParameterEvents();
       RegisterMaxCloseParameterEvents();
       RegisterCloseBiasLevelParameterEvents();
@@ -124,9 +117,4 @@
     }
 
-    private void RegisterMinCloseParameterEvents() {
-      MinCloseParameter.ValueChanged += (o, s) => ConfigureOperators(Operators);
-      MinCloseParameter.Value.ValueChanged += (o, s) => ConfigureOperators(Operators);
-    }
-
     private void RegisterMaxCloseParameterEvents() {
       MaxCloseParameter.ValueChanged += (o, s) => ConfigureOperators(Operators);
@@ -156,6 +144,6 @@
     #region Encoding Parameters
     [Storable]
-    private IFixedValueParameter<IntValue> minLengthParameter;
-    public IFixedValueParameter<IntValue> MinLengthParameter
+    private IValueParameter<IntValue> minLengthParameter;
+    public IValueParameter<IntValue> MinLengthParameter
     {
       get { return minLengthParameter; }
@@ -174,6 +162,6 @@
 
     [Storable]
-    private IFixedValueParameter<IntValue> maxLengthParameter;
-    public IFixedValueParameter<IntValue> MaxLengthParameter
+    private IValueParameter<IntValue> maxLengthParameter;
+    public IValueParameter<IntValue> MaxLengthParameter
     {
       get { return maxLengthParameter; }
@@ -192,24 +180,6 @@
 
     [Storable]
-    private IFixedValueParameter<IntValue> minCloseParameter;
-    public IFixedValueParameter<IntValue> MinCloseParameter
-    {
-      get { return minCloseParameter; }
-      set
-      {
-        if (value == null) throw new ArgumentNullException("Min close parameter must not be null.");
-        if (value.Value == null) throw new ArgumentNullException("Min close parameter value must not be null.");
-        if (minCloseParameter == value) return;
-
-        if (minCloseParameter != null) Parameters.Remove(minCloseParameter);
-        minCloseParameter = value;
-        Parameters.Add(minCloseParameter);
-        OnMinCloseParameterChanged();
-      }
-    }
-
-    [Storable]
-    private IFixedValueParameter<IntValue> maxCloseParameter;
-    public IFixedValueParameter<IntValue> MaxCloseParameter
+    private IValueParameter<IntValue> maxCloseParameter;
+    public IValueParameter<IntValue> MaxCloseParameter
     {
       get { return maxCloseParameter; }
@@ -228,6 +198,6 @@
 
     [Storable]
-    private IFixedValueParameter<DoubleValue> closeBiasLevelParameter;
-    public IFixedValueParameter<DoubleValue> CloseBiasLevelParameter
+    private IValueParameter<DoubleValue> closeBiasLevelParameter;
+    public IValueParameter<DoubleValue> CloseBiasLevelParameter
     {
       get { return closeBiasLevelParameter; }
@@ -246,6 +216,6 @@
 
     [Storable]
-    private IFixedValueParameter<PercentValue> inInstructionProbabilityParameter;
-    public IFixedValueParameter<PercentValue> InInstructionProbabilityParameter
+    private IValueParameter<PercentValue> inInstructionProbabilityParameter;
+    public IValueParameter<PercentValue> InInstructionProbabilityParameter
     {
       get { return inInstructionProbabilityParameter; }
@@ -321,10 +291,4 @@
     }
 
-    public int MinClose
-    {
-      get { return MinCloseParameter.Value.Value; }
-      set { MinCloseParameter.Value.Value = value; }
-    }
-
     public int MaxClose
     {
@@ -341,7 +305,7 @@
 
     #region Operator Discovery
-    private static readonly IEnumerable<Type> encodingSpecificOperatorTypes;
+    private static readonly IEnumerable<Type> EncodingSpecificOperatorTypes;
     static PlushEncoding() {
-      encodingSpecificOperatorTypes = new List<Type>() {
+      EncodingSpecificOperatorTypes = new List<Type>() {
         typeof (IPlushOperator),
         typeof (IPlushCreator),
@@ -353,5 +317,5 @@
     private void DiscoverOperators() {
       var assembly = typeof(IPlushOperator).Assembly;
-      var discoveredTypes = ApplicationManager.Manager.GetTypes(encodingSpecificOperatorTypes, assembly, true, false, false);
+      var discoveredTypes = ApplicationManager.Manager.GetTypes(EncodingSpecificOperatorTypes, assembly, true, false, false);
       var operators = discoveredTypes.Select(t => (IOperator)Activator.CreateInstance(t));
       var newOperators = operators.Except(Operators, new TypeEqualityComparer<IOperator>()).ToList();
@@ -374,6 +338,5 @@
         creator.MinLengthParameter.ActualName = MinLengthParameter.Name;
         creator.MaxLengthParameter.ActualName = MaxLengthParameter.Name;
-        creator.MinCloseParameter.ActualName = MinCloseParameter.Name;
-        creator.MaxCloseParameter.ActualName = MinCloseParameter.Name;
+        creator.MaxCloseParameter.ActualName = MaxCloseParameter.Name;
         creator.CloseBiasLevelParameter.ActualName = CloseBiasLevelParameter.Name;
         creator.ErcOptionsParameter.ActualName = ErcOptionsParameter.Name;
